//+------------------------------------------------------------------
//|
//|
//| volumeRev
//|
//|
//+------------------------------------------------------------------
#property copyright "alToronto"
#property link      "www.gmail.com"

#property indicator_chart_window
#property indicator_buffers    2
#property indicator_color1     clrDeepSkyBlue
#property indicator_color2     clrPaleVioletRed
#property indicator_width1     2
#property indicator_width2     2

//
//
//
//
//
extern double            Arrow_offset    = 2;
extern bool              useMA           = false;
input int                MA_Period       = 10;//MA Period
input int                MA_Shift        = 0;//MA Shift
input ENUM_MA_METHOD     MA_Method       = 0;//MA Method
input bool               alertsOn        = true;             // Alerts on true/false?
input bool               alertsOnCurrent = false;            // Alerts on open bar true/false?
input bool               alertsMessage   = true;             // Alerts message true/false?
input bool               alertsSound     = false;            // Alerts sound true/false?
input bool               alertsEmail     = false;            // Alerts email true/false?
input bool               alertsNotify    = false;            // Alerts notification true/false?

double signUp[];
double signDn[];
double volumeBuffer[];
double volumeMA[];

//+------------------------------------------------------------------
//|                                                                  
//+------------------------------------------------------------------
//
//
//
//
//

int init()
{
   IndicatorBuffers(3);
      SetIndexBuffer(0,signUp); SetIndexStyle(0,DRAW_ARROW); SetIndexArrow(0,159);
      SetIndexBuffer(1,signDn); SetIndexStyle(1,DRAW_ARROW); SetIndexArrow(1,159);
      SetIndexBuffer(2,volumeBuffer);
   return(0);
}
int deinit() { return(0); }

//+------------------------------------------------------------------
//|                                                                  
//+------------------------------------------------------------------
//
//
//
//
//

int start()
{
   int i,limit,counted_bars=IndicatorCounted();

   if(counted_bars < 0) return(-1);
   if(counted_bars > 0) counted_bars--;
         limit = MathMin(Bars-counted_bars,Bars-1);

   //
   //
   //

   for(i=limit; i>=0; i--) volumeBuffer[i] = Volume[i];
   for(i=limit; i>=0; i--)
   {
                     
         signUp[i] = signDn[i] = EMPTY_VALUE;
         volumeMA[i] = iMAOnArray(volumeBuffer,0,MA_Period,MA_Shift,MA_Method,i);
         
         if ((!useMA && Volume[i+1]>Volume[i+2]) || (useMA && Volume[i+1])) {
                  
         if ( (Low[i]<=Low[i+2]) &&
						(Close[i]>=Close[i+1]) && (Close[i]>=Open[i]) &&
						(Close[i] > Low[i])) 
					{
						//Signal 1
						if (Low[i]<=Low[i+1]) signUp[i] = Low[i]-iATR(NULL,0,10,i)/Arrow_offset;
						// signal 2
						else if (Low[i]>=Low[i+1]) signUp[i] = Low[i]-iATR(NULL,0,10,i)/Arrow_offset;
 
					}
			
			else if((High[i]>=High[i+2]) && 
						(Close[i]<=Close[i+1]) && (Close[i]<=Open[i]) &&
						((Close[i])<(High[i])) )	
					{
						//signal 1
						if (High[i]>=High[i+1]) signDn[i] = High[i] +iATR(NULL,0,10,i)/Arrow_offset;					
						//  signal 2
						else if (High[i]<=High[i+1]) signDn[i] = High[i] +iATR(NULL,0,10,i)/Arrow_offset;		
							
					}

      }            
   }
   manageAlerts();
   return(0);
}

//-------------------------------------------------------------------
//                                                                  
//-------------------------------------------------------------------

void manageAlerts()
{
   if (alertsOn)
   {
      int whichBar = (alertsOnCurrent) ? 0 : 1;
      if (signDn[whichBar] != EMPTY_VALUE || signUp[whichBar] != EMPTY_VALUE)
      {
         if (signUp[whichBar] != EMPTY_VALUE) doAlert(whichBar,"up");
         if (signDn[whichBar] != EMPTY_VALUE) doAlert(whichBar,"down");
      }
   }
}

//
//
//

void doAlert(int forBar, string doWhat)
{
   static string   previousAlert="nothing";
   static datetime previousTime;
   string message;
   
   if (previousAlert != doWhat || previousTime != Time[forBar]) {
       previousAlert  = doWhat;
       previousTime   = Time[forBar];

       //
       //
       //
       //
       //

       message = timeFrameToString(_Period)+" "+_Symbol+" at "+TimeToStr(TimeLocal(),TIME_SECONDS)+" volumeReversal "+doWhat;
             if (alertsMessage) Alert(message);
             if (alertsNotify)  SendNotification(message);
             if (alertsEmail)   SendMail(_Symbol+" volumeReversal ",message);
             if (alertsSound)   PlaySound("alert2.wav");
   }
}

//
//
//
//
//

string sTfTable[] = {"M1","M5","M15","M30","H1","H4","D1","W1","MN"};
int    iTfTable[] = {1,5,15,30,60,240,1440,10080,43200};

string timeFrameToString(int tf)
{
   for (int i=ArraySize(iTfTable)-1; i>=0; i--) 
         if (tf==iTfTable[i]) return(sTfTable[i]);
                              return("");
}



